<?php
namespace App\Controllers\V2;

use App\Controllers\BaseController;
use App\Libraries\MyUpload;
use App\Models\common\CodeModel;
use App\Models\v2\M704Model;

class M704 extends BaseController
{
    private $model, $codeModel;

    public function __construct()
    {
        $this->model = new M704Model();
        $this->codeModel = new CodeModel();
    }

    public function lists(): string
    {
        $codes = $this->codeModel->getCodeLists(['STEP_VERIFICATION', 'VRFCREQ_WAY', 'CP_ID', 'TEL_FAIL_CAUSE', 'ARTICLE_TYPE']); // 코드조회
        $sido = $this->model->getAreaList(); // 지역조회
        $bonbu = $this->model->getBonbuList();
        $team = $this->model->getTeamList();
        $user = $this->model->getUserList();

        $this->data['sido'] = $sido;
        $this->data['bonbu'] = $bonbu;
        $this->data['team'] = $team;
        $this->data['user'] = $user;
        $this->data['codes'] = $codes;

        return view("pages/v2/m704/lists", $this->data);
    }


    public function getResultList()
    {
        $start = (int) $this->request->getGet('start') ?: 0;
        $end = (int) $this->request->getGet('length') ?: 10;

        $data = [
            'atcl_no' => $this->request->getGet('atcl_no'), // 매물번호
            'stat_cd' => $this->request->getGet('stat_cd'), // 현재상태
            'realtor_nm' => $this->request->getGet('realtor_nm'), // 중개소
            'charger_gbn' => $this->request->getGet('charger_gbn'), // 배정여부
            'assign_yn' => $this->request->getGet('assign_yn'), // 배정여부2
            'receipt_sdate' => $this->request->getGet('receipt_sdate'), // 접수기간1
            'receipt_edate' => $this->request->getGet('receipt_edate'), // 접수기간2
            'stat_complete_date' => $this->request->getGet('stat_complete_date'), // 진행상태별시간유형
            'complete_sdate' => $this->request->getGet('complete_sdate'), // 진행상태별시간1
            'complete_edate' => $this->request->getGet('complete_edate'), // 진행상태별시간2
            'srcSido' => $this->request->getGet('srcSido'), // 시도
            'srcGugun' => $this->request->getGet('srcGugun'), // 시군구
            'srcDong' => $this->request->getGet('srcDong'), // 읍면동
            'bonbu' => $this->request->getGet('bonbu'), // 본부
            'team' => $this->request->getGet('team'), // 팀
            'damdang' => $this->request->getGet('damdang'), // 담당
            'vrfcreq_way' => $this->request->getGet('vrfcreq_way'), // 검증방식1
            'vrfc_type_sub' => $this->request->getGet('vrfc_type_sub'), // 검증방식2
            'rcpt_cpid' => $this->request->getGet('rcpt_cpid'), // 매체사
            'rlet_type_cd' => $this->request->getGet('rlet_type_cd'), // 매물종류
            'reference_file_url_yn' => $this->request->getGet('reference_file_url_yn'), // 참고용
            'corp_own' => $this->request->getGet('corp_own'), // 법인
        ];

        $totalCount = $this->model->getTotalCount($data);


        $datas = $this->model->getResultList($start, $end, $data);

        return $this->response->setJSON(body: [
            'recordsTotal' => $totalCount,
            'recordsFiltered' => $totalCount,
            'data' => $datas,
        ]);
    }

    // 엑셀 다운로드
    public function excel()
    {
        try {

            $data = [
                'atcl_no' => $this->request->getGet('atcl_no'), // 매물번호
                'stat_cd' => $this->request->getGet('stat_cd'), // 현재상태
                'realtor_nm' => $this->request->getGet('realtor_nm'), // 중개소
                'charger_gbn' => $this->request->getGet('charger_gbn'), // 배정여부
                'assign_yn' => $this->request->getGet('assign_yn'), // 배정여부2
                'receipt_sdate' => $this->request->getGet('receipt_sdate'), // 접수기간1
                'receipt_edate' => $this->request->getGet('receipt_edate'), // 접수기간2
                'stat_complete_date' => $this->request->getGet('stat_complete_date'), // 진행상태별시간유형
                'complete_sdate' => $this->request->getGet('complete_sdate'), // 진행상태별시간1
                'complete_edate' => $this->request->getGet('complete_edate'), // 진행상태별시간2
                'srcSido' => $this->request->getGet('srcSido'), // 시도
                'srcGugun' => $this->request->getGet('srcGugun'), // 시군구
                'srcDong' => $this->request->getGet('srcDong'), // 읍면동
                'bonbu' => $this->request->getGet('bonbu'), // 본부
                'team' => $this->request->getGet('team'), // 팀
                'damdang' => $this->request->getGet('damdang'), // 담당
                'vrfcreq_way' => $this->request->getGet('vrfcreq_way'), // 검증방식1
                'vrfc_type_sub' => $this->request->getGet('vrfc_type_sub'), // 검증방식2
                'rcpt_cpid' => $this->request->getGet('rcpt_cpid'), // 매체사
                'rlet_type_cd' => $this->request->getGet('rlet_type_cd'), // 매물종류
                'reference_file_url_yn' => $this->request->getGet('reference_file_url_yn'), // 참고용
                'corp_own' => $this->request->getGet('corp_own'), // 법인
            ];

            $datas = $this->model->getExcelList($data);

            return $this->response->setJSON(body: [
                'data' => $datas,
            ]);

        } catch (\Exception $e) {
            $e->getPrevious()->getTraceAsString();
        }
    }


    // 상세화면
    public function detail($id)
    {
        $id = (int) $id;

        if ($id <= 0) {
            throw \CodeIgniter\Exceptions\PageNotFoundException::forPageNotFound();
        }

        $codes = $this->codeModel->getCodeLists(['VRFCREQ_WAY', 'CONFIRM_RESULT_D11', 'CONFIRM_RESULT_T11', 'TEL_FAIL_CAUSE']); // 코드조회

        $data = $this->model->getDetail($id);
        $memo = $this->model->getMemo($id);
        $history = $this->model->getHistory($id);

        $regist2 = $this->model->oneGetRecordInfo($id, "2");	//등기부등본
        $phone_list = $this->model->getPhoneNumber(); // 주택임대사업자번호 리스트
        $tel = $this->model->getRecordInfo($id, '3'); //녹취파일

        $this->data['codes'] = $codes;

        $this->data['data'] = $data;
        $this->data['memo'] = $memo;
        $this->data['history'] = $history;
        $this->data['regist2'] = $regist2;
        $this->data['phone_list'] = $phone_list;
        $this->data['tel'] = $tel;

        return view("pages/v2/m704/detail", $this->data);
    }

    // 파일업로드
    public function uploadFile()
    {
        $lib = new MyUpload();

        try {
            $usr_id = session('usr_id');
            $vr_sq = $this->request->getPost('vr_sq');

            $file = $this->request->getFile('file');

            if ($file && $file->isValid() && !$file->hasMoved()) {

                $uploadPath = "/upload/v2_file/multi_" . $vr_sq . "/";

                $arrUploadfile = [];
                if ($file->isValid() && !$file->hasMoved()) {
                    $uploadData = $lib->do_upload2($file, $uploadPath);

                    if ($uploadData !== false) {
                        $arrUploadfile[] = $uploadData;
                    }
                }

                if (!empty($arrUploadfile)) {
                    foreach ($arrUploadfile as $key => $uploadFile) {
                        $data = [
                            'vr_sq' => $vr_sq,
                            // 'file_sq' => $this->request->getPost('file_sq'),
                            'orig_name' => $uploadFile['origin_name'],
                            'new_name' => $uploadFile['file_name'],
                            'file_path' => $uploadPath, // 필요에 따라 상대경로로만 저장
                            'ext' => '.' . $uploadFile['ext'],
                            'size' => $file->getSize(),
                            'img_yn' => null,
                            'img_height' => null,
                            'img_width' => null,
                            'usr_id' => $usr_id,
                        ];
                    }

                    if (!empty($data)) {
                        // 파일업로드 이력 저장
                        $this->model->saveChangedHistory($vr_sq, '30', 'C26', $usr_id, '녹취파일 업로드');

                        // 파일업로드 정보 저장
                        $this->model->saveFileInfo($data);

                    }

                }

            }


            return $this->response->setJSON([
                'code' => '0',
                'msg' => 'success'
            ]);


        } catch (\Exception $e) {
            return $this->response->setJSON([
                'code' => '9',
                'msg' => $e->getMessage(),
            ]);
        }
    }


    // 메모저장
    public function saveMemo()
    {
        try {

            $vr_sq = $this->request->getPost('vr_sq');
            $memo = $this->request->getPost('memo');

            $data = [
                $memo,
                $vr_sq,
            ];

            // UPDATE v2_vrfc_req
            $this->model->saveMemo($data);

            return $this->response->setJSON([
                'code' => '0',
                'msg' => 'success'
            ]);

        } catch (\Exception $e) {
            return $this->response->setJSON([
                'code' => '9',
                'msg' => $e->getMessage(),
            ]);
        }
    }


    // 다음 매물정보 조회
    public function getNextTelInfo()
    {
        try {

            $vr_sq = $this->request->getPost('vr_sq');

            $data = $this->model->getNextTelInfo($vr_sq);

            if (empty($data)) {
                return $this->response->setJSON([
                    'code' => '9',
                    'msg' => '전화매물이 존재하지 않습니다.'
                ]);
            } else {
                return $this->response->setJSON([
                    'code' => '0',
                    'msg' => 'success',
                    'data' => $data
                ]);
            }


        } catch (\Exception $e) {
            return $this->response->setJSON([
                'code' => '9',
                'msg' => $e->getMessage(),
            ]);
        }
    }
}